package net.sf.sido.constraint.support;

import java.math.BigDecimal;

import net.sf.sido.constraint.ConstraintDefinition;
import net.sf.sido.constraint.LTEConstraint;

import org.apache.commons.lang.StringUtils;

import com.google.common.base.Predicate;

public class LTEConstraintParser<N extends Number> implements ConstraintParser<N> {

	@Override
	public Predicate<N> parse(ConstraintDefinition constraintDefinition) {
		String max = constraintDefinition.getParameter("max", true, false, null);
		if (StringUtils.isBlank(max)) {
			throw new DOConstraintFieldNotFoundException("max");
		} else {
			BigDecimal maxValue = new BigDecimal(max);
			return new LTEConstraint<N>(maxValue);
		}
	}
}
