package net.sf.sido.editor;

import org.apache.commons.lang.StringUtils;
import org.joda.time.Duration;
import org.joda.time.format.ISOPeriodFormat;

public class DurationEditor implements DataEditor<Duration> {

	@Override
	public String toString(Duration value) {
		if (value == null) {
			return null;
		} else {
			return ISOPeriodFormat.standard().print(value.toPeriod());
		}
	}

	@Override
	public Duration valueOf(String value) {
		if (StringUtils.isBlank(value)) {
			return null;
		} else {
			return ISOPeriodFormat.standard().parsePeriod(value)
					.toStandardDuration();
		}
	}

}
