package net.sf.sido.support;

import java.util.Map;

import net.sf.sido.MetaInfo;

import com.google.common.collect.ImmutableMap;

public class DefaultMetaInfo implements MetaInfo {

	private final Map<String, Object> map;

	public DefaultMetaInfo(Map<String, Object> map) {
		this.map = ImmutableMap.copyOf(map);
	}

	@Override
	public boolean getBoolean(String name, boolean defaultValue) {
		Boolean value = (Boolean) this.map.get(name);
		if (value == null) {
			return defaultValue;
		} else {
			return value;
		}
	}

	@Override
	public int getInteger(String name, int defaultValue) {
		Integer value = (Integer) this.map.get(name);
		if (value == null) {
			return defaultValue;
		} else {
			return value;
		}
	}

	@Override
	public <T> T getObject(String name, T defaultValue) {
		@SuppressWarnings("unchecked")
		T value = (T) this.map.get(name);
		if (value == null) {
			return defaultValue;
		} else {
			return value;
		}
	}

	@Override
	public String getString(String name, String defaultValue) {
		return getObject(name, defaultValue);
	}

	@SuppressWarnings("unchecked")
	@Override
	public <T> Class<? super T> getType(String name) {
		return (Class<? super T>) this.map.get(name);
	}

}
